#!/usr/local/bin/perl

# TEST SERVER

# This is an iterative SCGI server, written in Perl, using the /usr/ports/www/p5-SCGI
# module.  I use it to test and debug Drood's SCGI support.  If you wish to run it
# yourself, you will need to install that module.

use SCGI;
use IO::Socket;

$socket = IO::Socket::INET->new( Listen => 10,
                                 ReuseAddr => 1,
                                 LocalPort => 4000 );

$scgi = SCGI->new( $socket, blocking => 1 );

while( $request = $scgi->accept )
{
   $request->read_env;
   read $request->connection, $body, $request->env->{ CONTENT_LENGTH };

   print { $request->connection } "Content-Type: text/html\n\n";
   print { $request->connection }
      "<html><head><title>SCGI Test Program</title>\n",
      "<body><h1>SCGI Test Program</h1>",
      "<table>\n",
      "<tr><td>SCGI:</td><td>",            $request->env->{ SCGI },            "</td></tr>",
      "<tr><td>REQUEST_METHOD:</td><td>",  $request->env->{ REQUEST_METHOD },  "</td></tr>",
      "<tr><td>CONTENT_TYPE:</td><td>",    $request->env->{ CONTENT_TYPE },    "</td></tr>",
      "<tr><td>CONTENT_LENGTH:</td><td>",  $request->env->{ CONTENT_LENGTH },  "</td></tr>",
      "<tr><td>QUERY_STRING:</td><td>",    $request->env->{ QUERY_STRING },    "</td></tr>",
      "<tr><td>HTTP_USER_AGENT:</td><td>", $request->env->{ HTTP_USER_AGENT }, "</td></tr>",
      "<tr><td>HTTP_COOKIE:</td><td>",     $request->env->{ HTTP_COOKIE },     "</td></tr>",
      "<tr><td>SCRIPT_NAME:</td><td>",     $request->env->{ SCRIPT_NAME },     "</td></tr>",
      "<tr><td>REMOTE_ADDR:</td><td>",     $request->env->{ REMOTE_ADDR },     "</td></tr>",
      "<tr><td>SERVER_NAME:</td><td>",     $request->env->{ SERVER_NAME },     "</td></tr>",
      "<tr><td>SERVER_SOFTWARE:</td><td>", $request->env->{ SERVER_SOFTWARE }, "</td></tr>",

      "</table></body></html>";

   $request->close;
}
